<template>
  <div id="communicator">
    <v-card class="d-flex flex-row mb-6" flat tile>
      <v-card id="list" height="400" width="256" class="mx-auto">
        <v-navigation-drawer permanent>
          <v-list-item>
            <v-list-item-content>
              <v-list-item-title class="text-h6">
                Konwersacje
              </v-list-item-title>
              <v-list-item-subtitle>
                Aby zablokować lub odblokować <br />użytkownika, kliknij na
                nicku<br />
                prawym klawiszem myszy.
              </v-list-item-subtitle>
            </v-list-item-content>
          </v-list-item>
          <v-divider></v-divider>
          <div v-on:click.right="handleContextMenu">
            <v-list dense nav>
              <PersonInList v-for="(person, index) in persons" :key="index" :selectUser="selectUser" :person="person"
                :persons="persons" :index="index" :selectedPerson="selectedPerson" />
            </v-list>
            <div class="text-center blocking">
              <v-dialog v-model="contentMenuBlockVisible" width="500">
                <v-card>
                  <v-card-title class="text-h5 grey lighten-2">
                    Blokowanie użytkownika
                  </v-card-title>
                  <v-card-text style="padding: 10px; text-align: center">
                    {{ this.contextMenuMessage }}
                  </v-card-text>
                  <v-divider></v-divider>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="
                      unblockUser();
                    contentMenuBlockVisible = false;
                    ">
                      Chcę mieć kontakt
                    </v-btn>
                    <v-btn color="error" text @click="() => {
                      blockUser();
                      contentMenuBlockVisible = false;
                    }
                      ">
                      <span>Blokuj użytkownika</span>
                      <v-icon color="error">mdi-cancel</v-icon>
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
            </div>
          </div>
        </v-navigation-drawer>
      </v-card>
      <v-card class="pa-2" outlined tileZ width="80vw">

        <div v-if="isArrowVisible && selectedPerson?.nick" class="arrow-container" @click="$bus.$emit('scroll-messages')">
          <div class="content">
            <svg id="more-arrows">
              <polygon class="arrow-top" points="37.6,27.9 1.8,1.3 3.3,0 37.6,25.3 71.9,0 73.7,1.3 " />
              <polygon class="arrow-middle" points="37.6,45.8 0.8,18.7 4.4,16.4 37.6,41.2 71.2,16.4 74.5,18.7 " />
              <polygon class="arrow-bottom" points="37.6,64 0,36.1 5.1,32.8 37.6,56.8 70.4,32.8 75.5,36.1 " />
            </svg>
          </div>
        </div>
        <TalksComponent v-if="selectedPerson?.nick && !error" :person="selectedPerson" :wave="wave"
        @scrolled-to-bottom="()=>{ isArrowVisible=false}" @un-scrolled="()=>{ isArrowVisible=true}" />
        <NoPersonSelected v-if="!selectedPerson?.nick && !error && fetched" :listNotEmpty="persons.length > 0" />
        <PersonSelectionServerError v-if="error" />
      </v-card>
    </v-card>
    <v-snackbar class="snackbar" :multi-line="true" v-model="snackbarYouAreBlocked">
      Ten użytkownik Cię zablokował
      <template v-slot:action="{ attrs }">
        <v-btn color="pink" text v-bind="attrs" @click="snackbarYouAreBlocked = false">
          Close
        </v-btn>
      </template>
    </v-snackbar>
  </div>
</template>
<script>



export default {

  data() {
    return {
      persons: [],
      error: false,
      right: null,
      selectedPerson: { nick: null },
      wave: false,
      message: false,
      contentMenuBlockVisible: false,
      contentMenuPosition: [0, 0],
      toBeBlockedUnblocked: null,
      contextMenuMessage: '',
      snackbarYouAreBlocked: false,
      fetched: false,
      isArrowVisible: true
    };
  },

  mounted() {


    this.$bus.$on('get-friends', this.getFriends());
    setTimeout(async () => {
      this.getFriends();
      await this.$forceUpdate();
      this.fetched = true;
      if (this.$route.query?.nick) {
        debugger
      const person = this.persons.find(person=>
        person.nick === this.$route.query?.nick
      )
      if(!person) {
        this.persons.push({ nick: this.$route.query?.nick });
        this.selectedPerson = this.persons.at(-1);
      } else {
        this.selectedPerson = person;
      }


      if (this.$route.query?.operation === 'wave') {
        this.wave = true;
        this.$axios
          .post(this.$config.serverUrl + '/user/wave', {
            uuid: this.$store.state.user.uuid,
            nick: this.$route.query.nick,
          })
          .then((data) => {
            console.log(data);
          })
          .catch((err) => {
            console.error('err');
            console.error(err);
          });
      }
      if (this.$route.query?.operation === 'message') {
        this.message === true;
      }
    }

    }, 4000);


    this.$bus.$on('wave-to', async ({ nick }) => {
      await this.persons.map((el) => {
        if (el?.nick === nick) {
          this.selectedPerson = el;
        }
      });
    });

    this.$bus.$on('message', async ({ nick }) => {
      await this.persons.map((el) => {
        if (el.nick === nick) {
          this.selectedPerson = el;
        }
      });
    });

    this.$bus.$on('unreceivedMesages', async (data) => {
      if (!data) return;
      await this.persons.forEach((el) => {
        if (data[el.nick]) {
          el.nrOfMessages += data[el.nick]?.length;
        }

      });
      this.$forceUpdate();
    });

    this.$bus.$on('loggedOut', (nick) => {
      const person = this.persons.find(el => el.nick === nick);
      if (!person) return;
      person.loggedIn = false;
    })

    this.$bus.$on('loggedIn', (nick) => {
      debugger
      const person = this.persons.find(el => el.nick === nick);
      if (!person) return;
      person.loggedIn = true;
    })

    this.$bus.$on('blocked', (nick) => {
      for (let i = 0, max = this.persons.length; i < max; i++) {
        if (this.persons[i].nick == nick) {
          this.persons[i].blocked = true;
          this.$bus.$emit('refresh-person-in-list');
          this.getFriends();
          break;
        }
      }
    })

    this.$bus.$on('unblocked', (nick) => {
      for (let i = 0, max = this.persons.length; i < max; i++) {
        if (this.persons[i].nick == nick) {
          this.persons[i].blocked = false;
          this.selectedPerson.blocked = false;
          this.$bus.$emit('refresh-person-in-list');
          this.getFriends();
          break;
        }
      }
    })

    document.addEventListener('click', ($event) => {
      if ($event.target.getAttribute.id !== 'context-menu') {
        this.contentMenuBlockVisible = false;
      }
    });

    if (this.$route.query.search === 'true') {
      this.$bus.$emit('menu-item', { title: 'Szukaj miłości' });
    }


  },

  methods: {

    getFriends() {
      this.$axios
        .post(this.$config.serverUrl + '/user/friends', {
          uuid: this.$store.state.user.uuid,
        })
        .then(async ({ data }) => {

          if (!Array.isArray(data)) {
            return;
          }
          this.persons = data;

          for (let i = 0, max = this.persons.length; i < max; i++) {
            this.$axios.get(this.$config.serverUrl + '/users/check-if-blocks-is-blocked/', {
              params: {
                nick: this.$store.state.user.nick, friend: this.persons[i].nick
              }
            }).then(({ data }) => {
              debugger
              this.persons[i].blocks = null;
              this.persons[i].blocked=null;
              if (data.blocks) {
                this.persons[i].blocks = data.blocks;
                this.$bus.$emit('block-user');
              }
              if (data.blocked) {
                this.persons[i].blocked = data.blocked;
                this.$bus.$emit('block-user');
              }

              this.$forceUpdate();

            }).catch(err => {
              console.error(err)
            });
          }

          if (typeof this.$route.query.nick !== 'undefined') {
            this.getFriend();
          }

          this.countMessages(this.$store.state.unreceivedMesages);

          this.$bus.$on('unreceivedMesages', async (data) => {
            await this.countMessages(data);
            this.$forceUpdate();
          });
        })
        .catch((err) => {
          console.error('Error');
          console.error(err);
          this.error = true;
        });
    },
    getFriend() {
      this.$axios.post(this.$config.serverUrl + '/user/friend',
        { uuid: this.$store.state.user.uuid, nick: this.$route.query.nick }).then(({ data }) => {
          console.log(data);
          const person = this.persons.find(person=>person.nick===data.nick)
          if(person) return;
          this.persons.push(data);
        }).catch(err => {
          console.error(err);
        });
    },
    handleContextMenu($event) {
      const nick = $event.target.closest('[x-data]').getAttribute('x-data');
      const userToBeChangedBlocked = this.persons.find(
        (el) => el.nick === nick
      );
      debugger
      if(userToBeChangedBlocked.blocked) {
        return;
      }
      // if (userToBeChangedBlocked.blocks) {
      //   return;
      // }
      this.contentMenuBlockVisible = true;
      if (userToBeChangedBlocked.blocks) {
        this.contextMenuMessage = `Czy chcesz odblokować użytkownika ${nick}?`;
      } else {
        this.contextMenuMessage = `Czy chcesz zablokować użytkownika ${nick}?`;
      }
      const { clientX, clientY } = $event;
      this.contentMenuPosition = [clientX, clientY];
      this.toBeBlockedUnblocked = $event.target
        .closest('[x-data]')
        .getAttribute('x-data');
      $event.preventDefault();
    },

    selectUser(index) {
       this.selectedPerson = this.persons[index];
      if (this.selectedPerson.blocked) {
        this.snackbarYouAreBlocked = true;
      }
      this.$store.dispatch('selectPerson', this.selectedPerson.nick);
      this.$store.dispatch('removeUserFromUnreadMeassages', this.selectedPerson.nick);
      this.$bus.$emit('unreceivedMesages');
      const selectedPerson = this.persons.find(
        (el) => el.nick === this.selectedPerson.nick
      );
      selectedPerson.nrOfMessages = 0;
      const unreceivedMesages = this.$store.state.unreceivedMesages;
      unreceivedMesages[this.selectedPerson.nick] = [];
      this.$bus.$emit('unreceivedMesages', unreceivedMesages);
      this.$axios.put(this.$config.serverUrl + '/message/read', {
        uuid: this.$store.state.user.uuid,
        nick: this.selectedPerson.nick,
      });
    },

    blockUser() {
      this.$axios
        .put(this.$config.serverUrl + '/user/block', {
          uuid: this.$store.state.user.uuid,
          nick: this.toBeBlockedUnblocked,
        })
        .then((data) => {
          console.log(data);
          debugger;
          if (data.status === 200) {
          //   this.$set(this.persons.find(
          //     (el) => el.nick === this.toBeBlockedUnblocked
          //   ), 'blocked', true);//.blocked = true;
            this.$bus.$emit('block-user');
            this.getFriends();
            this.$forceUpdate();
          }
        })
        .catch((err) => {
          console.error(err);
        });
    },
    unblockUser() {
      this.$axios
        .put(this.$config.serverUrl + '/user/unblock', {
          uuid: this.$store.state.user.uuid,
          nick: this.toBeBlockedUnblocked,
        })
        .then((data) => {
          if(data.status ==='NOT OK') {
            return;
          }
          console.log(data);
          this.$set(this.persons.find(
            (el) => el.nick === this.toBeBlockedUnblocked
          ), 'blocked', false);
          this.selectedPerson.blocked = false;
          this.getFriends();
          this.$bus.$emit('un-block-user');
          this.$forceUpdate();
        })
        .catch((err) => {
          console.error(err);
        });
    },
    countMessages(unreceivedMesages) {
      if (!unreceivedMesages) return;
      this.persons.forEach((el) => {
        if (unreceivedMesages[el.nick]) {
          el.nrOfMessages = unreceivedMesages[el.nick]?.length || 0;
        } else {
          el.nrOfMessages = 0;
        }

        for (let i = 0, max = this.$store.state.unreadMeassages.length; i < max; i++) {
          if (this.$store.state.unreadMeassages[i].nick == el.nick) {
            el.nrOfMessages += this.$store.state.unreadMeassages[i].number;
          }
        }
      });
    },

  },
};
</script>
<style scoped lang="scss">
#communicator {
  .person-item {
    color: rgba(0, 0, 0, 0.7) !important;

    aside {
      position: relative;
      transform: translateX(-200px) !important;
      left: -188px !important;
    }

    &.selected {
      color: rgba(0, 0, 0, 1) !important;
      outline: 1px solid rgba(20, 20, 20, 0.65);
    }
  }

  .blocking {
    position: absolute;
    z-index: 9999;
  }
}

.arrow-container {
  transform: scale(.5);
  position: fixed;
  right: 30px;
  z-index: 99;
  padding: 20px;
  text-align: center;
}

.content {

  left: 50%;
  top: 50%;


  p {
    margin: 0 0 20px;
  }

}

/* Arrow & Hover Animation */
#more-arrows {
  width: 75px;
  height: 65px;

  &:hover {

    polygon {
      fill: #000;
      transition: all .2s ease-out;

      &.arrow-bottom {
        transform: translateY(-18px);
      }

      &.arrow-top {
        transform: translateY(18px);
      }

    }

  }

}

polygon {
  fill: #000;
  transition: all .2s ease-out;

  &.arrow-middle {
    opacity: 0.75;
  }

  &.arrow-top {
    opacity: 0.5
  }

}
</style>
